# $Revision: 1.16 $, $Date: 2004/12/14 08:34:16 $

%bcond_with blas	# with ACML interface to BLAS instead of direct vector operations

Summary:	A package for solving large sparse systems of linear equations
Summary(pl):	Pakiet do rozwizywania duych, rzadkich ukadw rwna liniowych
Name:		laspack
Version:	1.12.2
Release:	5%{?with_blas:BLAS}
License:	Freely distributable
Group:		Libraries
Source0:	http://www.netlib.org/linalg/%{name}.tgz
# Source0-md5:	fcfb3c86cc993e29eb477191b1136a8d
Source1:	%{name}-README.PLD
Patch0:		%{name}-automake_support.patch
Patch1:		%{name}-include.patch
%{?with_blas:Patch2:	%{name}-blas.patch}
URL:		http://www.tu-dresden.de/mwism/skalicky/laspack/laspack.html
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)
%if %{with blas}
ExclusiveArch:	amd64
%endif

%description
LASPack is a package for solving large sparse systems of linear
equations like those which arise from discretization of partial
differential equations. The primary aim of LASPack is the implementation
of efficient iterative methods for the solution of systems of linear
equations. 
Beside the obligatory Jacobi, succesive over-relaxation,
Chebyshev, and conjugate gradient solvers, LASPack contains selected
state-of-the-art algorithms which are commonly used for large sparse
systems:
  - CG-like methods for non-symmetric systems: CGN, GMRES, BiCG, QMR,
    CGS, and BiCGStab,
  - multilevel methods such as multigrid and conjugate gradient method
    preconditioned by multigrid and BPX preconditioners.
These algorithms are described in
http://www.netlib.org/linalg/html_templates/Templates.html 
LASPack is written in ANSI C and is thus largely portable.

%description -l pl
LASPack jest pakietem sucym do rozwizywania duych, rzadkich
ukadw rwna liniowych. Podstawowym jego celem jest implementacja
wydajnych metod iteracyjnych.
Poza obligatoryjn metod Jacobiego, relaksacji, Czebyszewa i
gradientow, LASPack zawiera wybrane nowoczesne algorytmy:
  - metody CG i podobne: CGN, GMRES, BiCG, QMR, CGS i BiCGStab,
  - metody wielopoziomowe takie jak multigrid i gradientowa, uywane z
    preconditionerami typu multigrid i BPX.
Wymienione wyej algorytmy zostay opisane w
http://www.netlib.org/linalg/html_templates/Templates.html
LASPack zosta napisany w ANSI C, jest wic bardzo przenony.

%package devel
Summary:	LASPack development files
Summary(pl):	Pliki programistyczne LASPack
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
LASPack development files.

%description devel -l pl
Pliki programistyczne LASPack.

%package static
Summary:	Static LASPack library
Summary(pl):	Statyczna biblioteka LASPack
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static LASPack library.

%description static -l pl
Statyczna biblioteka LASPack.

%package examples
Summary:	Example LASPack programs
Summary(pl):	Przykadowe programy korzystajce z LASPack
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Requires:	%{name}-xc-devel

%description examples
Example LASPack programs.

%description examples -l pl
Przykadowe programy korzystajce z LASPack.

%package xc
Summary:	Extensions of C string handling and command line options
Summary(pl):	Rozszerzenia dla funkcji C dziaajcych na opcjach linii polece i acuchach znakw
Group:		Libraries

%description xc
Extensions of C string handling and command line options.

%description xc -l pl
Rozszerzenia dla funkcji C dziaajcych na opcjach linii polece i
acuchach znakw.

%package xc-devel
Summary:	Development files for xc extensions
Summary(pl):	Pliki programistyczne dla rozszerze xc
Group:		Development/Libraries
Requires:	%{name}-xc = %{version}-%{release}

%description xc-devel
Development files for xc extensions.

%description xc-devel -l pl
Pliki programistyczne dla rozszerze xc.

%package xc-static
Summary:	Static xc extensions library
Summary(pl):	Biblioteka statyczna z rozszerzeniami xc
Group:		Development/Libraries
Requires:	%{name}-xc-devel = %{version}-%{release}

%description xc-static
Static xc extensions library.

%description xc-static -l pl
Biblioteka statyczna z rozszerzeniami xc.

%prep
%setup -q -c LASPACK
%patch0 -p1
%patch1 -p1
%if %{with blas}
%patch2 -p1
%endif

cp %{SOURCE1} README.PLD

%build
cd laspack
%{__libtoolize}
%{__aclocal}
%{__autoheader}
%{__autoconf}
%{__automake}
%configure %{?with_blas: LDFLAGS="-lg2c -lacml -lm"}

%{__make}

cd ../xc
%{__libtoolize}
%{__aclocal}
%{__autoheader}
%{__autoconf}
%{__automake}
%configure

%{__make}

%install
rm -rf $RPM_BUILD_ROOT


%{__make} -C laspack install \
	DESTDIR=$RPM_BUILD_ROOT

%{__make} -C xc install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -fr $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	xc -p /sbin/ldconfig
%postun	xc -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc readme README.PLD
%attr(755,root,root) %{_libdir}/liblaspack.so.*.*.*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/liblaspack.so
%doc laspack/doc/ laspack/html/
%{_libdir}/liblaspack.la
%{_includedir}/laspack

%files static
%defattr(644,root,root,755)
%{_libdir}/liblaspack.a

%files examples
%defattr(644,root,root,755)
%{_examplesdir}/%{name}-%{version}

%files xc
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libxc.so.*.*.*

%files xc-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libxc.so
%{_includedir}/xc

%files xc-static
%defattr(644,root,root,755)
%{_libdir}/libxc.a

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: laspack.spec,v $
Revision 1.16  2004/12/14 08:34:16  roman
- moved README.PLD from laspack-devel to laspack package
- release 5
- STBR

Revision 1.15  2004/12/14 02:59:29  roman
- --with blas should work on AMD 64 only, as it uses ACML

Revision 1.14  2004/12/14 02:56:00  roman
- added conditional build --with blas, to include BLAS patch (don't use it when building for distribution!)

Revision 1.13  2004/12/14 00:20:47  roman
- slightly extended description

Revision 1.12  2004/12/14 00:12:41  adamg
- if a file lies in CVS, don't add SourceX-md5 for it

Revision 1.11  2004/12/14 00:08:32  roman
- added README.PLD with info about modification of sources in PLD (license requirement)
- release 4
- STBR

Revision 1.10  2004/12/13 15:16:06  qboosh
- missing dirs, fixed pl ambiguity

Revision 1.9  2004/12/13 14:47:04  krolik
- added patch that fix paths to include files, rel.3
- STBR

Revision 1.8  2004/12/13 13:49:26  adamg
- release 2

Revision 1.7  2004/12/13 13:37:34  roman
- added log entry in spec
